MantisBT
Mantis Bug Tracker Workflow

View Issue Details Jump to Notes ] Related Changesets ] Issue History ] Print ]
IDProjectCategoryView StatusDate SubmittedLast Update
0030575Open CASCADE[OCCT] OCCT:Testspublic2019-03-15 00:112019-03-19 10:32
Reporterkgv 
Assigned Toapn 
PrioritynormalSeverityminor 
StatusverifiedResolutionfixed 
PlatformOSOS Version
Product Version[OCCT] 7.0.0 
Target Version[OCCT] 7.4.0Fixed in Version 
Summary0030575: Tests - v3d/materials unstable image screenshots of alpha-blending on GeForce with MSAA
DescriptionTest cases v3d/materials/bug24872_1,bug24872_2,bug24855 generates unstable image screenshots on GeForce hardware (Intel HD Graphics and AMD Radeon are not affected) within MSAA8 turned on at alpha-blended semitransparent surface.

It seems that hardware uses some optimization causing slight deviation of results from one execution to another - usually within 2/255 tolerance.

It is proposed extending testdiff to optionally use image color tolerance specified by the test, e.g. line:
> puts "IMAGE_COLOR_TOLERANCE: 0.008"
will ask testdiff to launch diffimage with "-toleranceOfColor 0.008" parameter.

Alternatively, specific test cases might take screenshots with MSAA turned off.
Steps To ReproduceN/A
TagsNo tags attached.
Test case numberNot needed
Attached Filespng file icon bug24855.png (110,187 bytes) 2019-03-15 00:31
png file icon diff-Debian80-64-bug24855.png (1,292 bytes) 2019-03-15 00:31

- Relationships
child of 0027338closedabv Minor corrections in Tcl samples and documentation 

-  Notes
(0082965)
git (administrator)
2019-03-15 00:26

Branch CR30575 has been created by kgv.

SHA-1: 1d970376a73cff54129ec87b3268d5badb2b2f69


Detailed log of new commits:

Author: kgv
Date: Fri Mar 15 00:12:12 2019 +0300

    0030575: Tests - v3d/materials unstable image screenshots of alpha-blending on GeForce with MSAA
    
    testdiff now looks for "IMAGE_COLOR_TOLERANCE: Tol" statements in log
    to execute diffimage with -toleranceOfColor Tol parameter.
    
    Image difference is first performed with 0 tolerance and then optionally with non-zero tolerance,
    so that the log always includes information that some images are different,
    but with two different messages:
    - "IMAGE differs" for images failed comparison;
    - "IMAGE is similar" for images passed comparison only with non-zero tolerance.
    
    v3d/materials are now compare image results with color tolerance 0.8% (accepts 2/255 difference max).
(0082966)
git (administrator)
2019-03-15 07:54

Branch CR30575 has been updated forcibly by kgv.

SHA-1: 20a3d9e8845f07280f0aa55cf9ea7e654c029691
(0082967)
git (administrator)
2019-03-15 08:33

Branch CR30575 has been updated forcibly by kgv.

SHA-1: c0549ef4d6a6f4ef72a0a7129d2c170e44c9d0b4
(0082969)
git (administrator)
2019-03-15 11:23

Branch CR30575_1 has been created by kgv.

SHA-1: e6eb5f96d46d43023952c1fea0c82425645432db


Detailed log of new commits:

Author: kgv
Date: Fri Mar 15 00:12:12 2019 +0300

    0030575: Tests - v3d/materials unstable image screenshots of alpha-blending on GeForce with MSAA
    
    testdiff now looks for "IMAGE_COLOR_TOLERANCE: Tol" statements in log
    to execute diffimage with -toleranceOfColor Tol parameter.
    
    Image difference is first performed with 0 tolerance and then optionally with non-zero tolerance,
    so that the log always includes information that some images are different,
    but with two different messages:
    - "IMAGE differs" for images failed comparison;
    - "IMAGE is similar" for images passed comparison only with non-zero tolerance.
    
    v3d/materials - disabled MSAA and removed duplicate.
    demo/samples/materials - compare screenshots with 0.8% color tolerance (2/255).
(0082987)
git (administrator)
2019-03-15 14:45

Branch CR30575_1 has been updated forcibly by kgv.

SHA-1: d3d808c24cfd3ecdaf52a7a0afd05bc436720580
(0082993)
git (administrator)
2019-03-15 16:02

Branch CR30575_1 has been updated forcibly by kgv.

SHA-1: 186c39d69281c86162894d7743c7194b085558e5
(0082994)
kgv (developer)
2019-03-15 16:02

Patch is ready for review.
(0083005)
apn (administrator)
2019-03-15 18:36

Reviewed, please proceed.
(0083006)
apn (administrator)
2019-03-15 18:39

Combination -
OCCT branch : CR30575_1
master SHA - 186c39d69281c86162894d7743c7194b085558e5
d67d4b811012eef8913d3c535c29654d0acf3c4c
Products branch : master SHA - 19cf12d4f918562ea1456aa224c6f7a64b9c4ad7
was compiled on Linux, MacOS and Windows platforms and tested in optimize mode.

Number of compiler warnings:
No new/fixed warnings

Regressions/Differences/Improvements:
No regressions/differences

CPU differences:
Debian80-64:
OCCT
Total CPU difference: 16626.479999999996 / 16596.889999999963 [+0.18%]
Products
Total CPU difference: 9094.240000000018 / 9092.71000000004 [+0.02%]
Windows-64-VC14:
OCCT
Total CPU difference: 17980.015625 / 17983.03125 [-0.02%]
Products
Total CPU difference: 10481.046875 / 10460.953125 [+0.19%]

Image differences :
No differences that require special attention

Memory differences :
No differences that require special attention
(0083076)
git (administrator)
2019-03-19 10:32

Branch CR30575_1 has been deleted by inv.

SHA-1: 186c39d69281c86162894d7743c7194b085558e5
(0083078)
git (administrator)
2019-03-19 10:32

Branch CR30575 has been deleted by inv.

SHA-1: c0549ef4d6a6f4ef72a0a7129d2c170e44c9d0b4

- Related Changesets
occt: master f2b42160
Timestamp: 2019-03-14 21:12:12
Author: kgv
Committer: apn
Details ] Diff ]
0030575: Tests - v3d/materials unstable image screenshots of alpha-blending on GeForce with MSAA

testdiff now looks for "IMAGE_COLOR_TOLERANCE: Tol" statements in log
to execute diffimage with -toleranceOfColor Tol parameter.

Image difference is first performed with 0 tolerance and then optionally with non-zero tolerance,
so that the log always includes information that some images are different,
but with two different messages:
- "IMAGE differs" for images failed comparison;
- "IMAGE is similar" for images passed comparison only with non-zero tolerance.

v3d/materials - disabled MSAA and removed duplicate.
demo/samples/materials - compare screenshots with 0.8% color tolerance (2/255).
mod - samples/tcl/materials.tcl Diff ] File ]
mod - src/DrawResources/TestCommands.tcl Diff ] File ]
mod - tests/demo/samples/materials Diff ] File ]
mod - tests/v3d/materials/bug24855 Diff ] File ]
rm - tests/v3d/materials/bug24872_1 Diff ] File ]
rm - tests/v3d/materials/bug24872_2 Diff ] File ]
add - tests/v3d/materials/phong1 Diff ] File ]
add - tests/v3d/materials/raytrace1 Diff ] File ]

- Issue History
Date Modified Username Field Change
2019-03-15 00:11 kgv New Issue
2019-03-15 00:11 kgv Assigned To => apn
2019-03-15 00:26 git Note Added: 0082965
2019-03-15 00:27 kgv Description Updated View Revisions
2019-03-15 00:31 kgv File Added: bug24855.png
2019-03-15 00:31 kgv File Added: diff-Debian80-64-bug24855.png
2019-03-15 00:33 kgv Relationship added child of 0027338
2019-03-15 00:33 kgv Product Version 7.3.0 => 7.0.0
2019-03-15 00:34 kgv Description Updated View Revisions
2019-03-15 07:54 git Note Added: 0082966
2019-03-15 08:33 git Note Added: 0082967
2019-03-15 11:23 git Note Added: 0082969
2019-03-15 14:45 git Note Added: 0082987
2019-03-15 16:02 git Note Added: 0082993
2019-03-15 16:02 kgv Note Added: 0082994
2019-03-15 16:02 kgv Status new => resolved
2019-03-15 18:36 apn Test case number => Not needed
2019-03-15 18:36 apn Note Added: 0083005
2019-03-15 18:36 apn Assigned To apn => bugmaster
2019-03-15 18:36 apn Status resolved => reviewed
2019-03-15 18:39 apn Note Added: 0083006
2019-03-15 18:39 apn Status reviewed => tested
2019-03-17 15:40 apn Changeset attached => occt master f2b42160
2019-03-17 15:40 apn Assigned To bugmaster => apn
2019-03-17 15:40 apn Status tested => verified
2019-03-17 15:40 apn Resolution open => fixed
2019-03-19 10:32 git Note Added: 0083076
2019-03-19 10:32 git Note Added: 0083078


Copyright © 2000 - 2019 MantisBT Team
Powered by Mantis Bugtracker